//master
#include <avr/io.h>
#include <util/delay.h>

#define DDR_SPI DDRB
#define DD_MOSI PB3
#define DD_MISO PB4
#define DD_SCK PB5
#define DD_SS PB2

void SPI_MasterInit(void)
{
  DDR_SPI = (1 << DD_MOSI) | (1 << DD_SCK) | (1 << DD_SS);
  DDRB |= (1<<DDB2);  // set SS as output
  SPCR = (1 << SPE) | (1 << MSTR);
  // SPCR = (1 << SPE) | (1 << MSTR) | (1 << SPR0) | (1 << DORD) | (1 << CPOL) | (1 << CPHA) | (1 << SPE);
  // SPSR = (1 << SPI2X) | (1 << WCOL) | (1 << SPIF);
}

void Print(byte *data2, int lenght){
  Serial.println("----");
  for(int i = 0; i < lenght; i++) {
    Serial.print(data2[i], HEX);
    Serial.print(" ");
  }
}

void SPI_MasterTransmit(char *data, int length)
{
  PORTB &= ~(1<<2);

  // Serial.println();
  int size = sizeof(data) / sizeof(data[0]);
  
  if (data[size - 1] == SPDR){
    Serial.println("Privet") ;   
  }
  byte check = 0;
  byte spdr[length];
  Serial.println();
  for(int i = 0; i < length; i++) {
    SPDR = data[i]; // отправляем байт массива
    Serial.print(data[i], HEX);
    Serial.print(" ");
    while (!(SPSR & (1 << SPIF))); // ждем, пока байт передастся
  }
  PORTB |= (1<<2);
}

void setup()
{
  Serial.begin(9600);
  SPI_MasterInit();   
  Serial.println("Master Initialization ");
}

// Функция для вычисления контрольной суммы XOR
byte calculateXORChecksum(byte *data, int length) {
  byte crc = 0x00;
  byte poly = 0x07; // полином для CRC8

  for (int i = 0; i < length-2; i++) {
      crc ^= data[i]; // XOR текущего байта с crc

      for (int j = 0; j < length; j++) {
          if (crc & 0x80) { // если старший бит crc равен 1
              crc = (crc << 1) ^ poly; // сдвигаем crc на 1 бит влево и XOR с полиномом
          } else {
              crc <<= 1; // иначе просто сдвигаем на 1 бит влево
          }
      }
  }

  return crc;
}


void loop()
{
  char data[] = {6, 1, 3, 5, 16, 17, 18, 0};
  
  int length = sizeof(data);

  const int last = data [ (sizeof(data) / sizeof(data[0]))-1];
  
  byte checking = calculateXORChecksum(data, length-1); 
  int size = sizeof(data) / sizeof(data[0]);
  data[size - 1] = checking;
  Print(data, size);
  // Serial.println(last);
  
  SPI_MasterTransmit(data, length);
  _delay_ms(1000);
}